<html>
<head>
<title>OgreDDSCodec.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreDDSCodec.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreDDSCodec_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OgreDDSCodec_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OgreDDSCodec_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreImageCodec_8h.html">OgreImageCodec.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040     <span class="comment">// Forward declarations</span>
<a name="l00041"></a>00041     <span class="keyword">struct </span>DXTColourBlock;
<a name="l00042"></a>00042     <span class="keyword">struct </span>DXTExplicitAlphaBlock;
<a name="l00043"></a>00043     <span class="keyword">struct </span>DXTInterpolatedAlphaBlock;
<a name="l00044"></a>00044 
<a name="l00050"></a><a class="code" href="classOgre_1_1DDSCodec.html">00050</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DDSCodec.html" title="Codec specialized in loading DDS (Direct Draw Surface) images.">DDSCodec</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ImageCodec.html" title="Codec specialized in images.">ImageCodec</a>
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052     <span class="keyword">private</span>:
<a name="l00053"></a><a class="code" href="classOgre_1_1DDSCodec.html#a63912ad1c6d9bbb128d01ce020d10ee1">00053</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1DDSCodec.html#a63912ad1c6d9bbb128d01ce020d10ee1">mType</a>;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055         <span class="keywordtype">void</span> flipEndian(<span class="keywordtype">void</span> * pData, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> count) <span class="keyword">const</span>;
<a name="l00056"></a>00056         <span class="keywordtype">void</span> flipEndian(<span class="keywordtype">void</span> * pData, <span class="keywordtype">size_t</span> size) <span class="keyword">const</span>;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> convertFourCCFormat(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> fourcc) <span class="keyword">const</span>;
<a name="l00059"></a>00059         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> convertPixelFormat(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> rgbBits, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> rMask, 
<a name="l00060"></a>00060             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> gMask, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> bMask, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> aMask) <span class="keyword">const</span>;
<a name="l00061"></a>00061 
<a name="l00063"></a>00063         <span class="keywordtype">void</span> unpackDXTColour(<a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> pf, <span class="keyword">const</span> DXTColourBlock&amp; block, <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>* pCol) <span class="keyword">const</span>;
<a name="l00065"></a>00065         <span class="keywordtype">void</span> unpackDXTAlpha(<span class="keyword">const</span> DXTExplicitAlphaBlock&amp; block, <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>* pCol) <span class="keyword">const</span>;
<a name="l00067"></a>00067         <span class="keywordtype">void</span> unpackDXTAlpha(<span class="keyword">const</span> DXTInterpolatedAlphaBlock&amp; block, <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>* pCol) <span class="keyword">const</span>;
<a name="l00068"></a>00068 
<a name="l00070"></a><a class="code" href="classOgre_1_1DDSCodec.html#a46a9a596e479220b79c805d0be1b69cc">00070</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1DDSCodec.html" title="Codec specialized in loading DDS (Direct Draw Surface) images.">DDSCodec</a>* <a class="code" href="classOgre_1_1DDSCodec.html#a46a9a596e479220b79c805d0be1b69cc" title="Single registered codec instance.">msInstance</a>;
<a name="l00071"></a>00071     <span class="keyword">public</span>:
<a name="l00072"></a>00072         <a class="code" href="classOgre_1_1DDSCodec.html" title="Codec specialized in loading DDS (Direct Draw Surface) images.">DDSCodec</a>();
<a name="l00073"></a><a class="code" href="classOgre_1_1DDSCodec.html#a033bc39aab1445bb54e509bcc0ce5408">00073</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1DDSCodec.html#a033bc39aab1445bb54e509bcc0ce5408">~DDSCodec</a>() { }
<a name="l00074"></a>00074 
<a name="l00076"></a>00076         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> code(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">MemoryDataStreamPtr</a>&amp; input, CodecDataPtr&amp; pData) <span class="keyword">const</span>;
<a name="l00078"></a>00078         <span class="keywordtype">void</span> codeToFile(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">MemoryDataStreamPtr</a>&amp; input, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; outFileName, CodecDataPtr&amp; pData) <span class="keyword">const</span>;
<a name="l00080"></a>00080         DecodeResult decode(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; input) <span class="keyword">const</span>;
<a name="l00082"></a>00082         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> magicNumberToFileExt(<span class="keyword">const</span> <span class="keywordtype">char</span> *magicNumberPtr, <span class="keywordtype">size_t</span> maxbytes) <span class="keyword">const</span>;
<a name="l00083"></a>00083         
<a name="l00084"></a>00084         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getType() <span class="keyword">const</span>;        
<a name="l00085"></a>00085 
<a name="l00087"></a>00087         <span class="keyword">static</span> <span class="keywordtype">void</span> startup(<span class="keywordtype">void</span>);
<a name="l00089"></a>00089         <span class="keyword">static</span> <span class="keywordtype">void</span> shutdown(<span class="keywordtype">void</span>);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091     };
<a name="l00095"></a>00095 } <span class="comment">// namespace</span>
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="preprocessor">#endif</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
